<template>
	<div class="builder lightestpink-color" :class="stats_classes">
		<div class="header flex space">		
			<div class="node-info">
				<div class="flex space v-top">
					<div class="type hustle medium lightest-pink-color">{{getLocale('structure_main_builder')}}</div>
					<div class="level medium-font">LV{{node.data.level}}</div>
				</div>
				
				<v-button 
					v-if="node.data.level < structureMaxLevel('builder')"
					v-tooltip="'builder_powerup'"
					:text="getLocale('upgrade')"
					:secondary_text="structureUpgradeCost('builder', node.data.level)"
					:icons="[ 'bytes_black.svg' ]"
					:disabled="checkStructureByteCost('builder', node.data.level) || upgrade_node_lock"
					color="lightestpink"
					@clicked="upgradeNode(node.id)"
				/>
			</div>
			
			<div class="level-bar">
				<div class="bar">
					<div class="base lightestpink-bkg" :style="{width : (4*node.data.level)+'%'}"></div>
				</div>
				
				<div class="bonus" :class="{'active' : node.data.level >= 10}" :style="{left : '40%'}" v-tooltip="'builder_perk_1'">
					<div class="icon lightestpink-border"></div>
					<div class="level bold">LV10</div>
					<div class="effect">{{getLocale('builder_perk_1_label')}}</div>
				</div>
				
				<div class="bonus" :class="{'active' : node.data.level >= 20}" :style="{left : '80%'}" v-tooltip="'builder_perk_2'">
					<div class="icon lightestpink-border"></div>
					<div class="level bold">LV20</div>
					<div class="effect">{{getLocale('builder_perk_2_label')}}</div>
				</div>
			</div>
			
			<tutorial-icon color="#feb3ff" @clicked="setTutorial('builder', -1, true)"/>
		</div>
	
		<div class="content lightestpink-border flex space v-top">
			<v-info 
				class="efficiency" 
				color="#FEB3FF" 
				:text="Math.floor(structureEffect('builder', node.data.level)*100)+'%'" 
				v-tooltip="'main_efficiency_tooltip'"
			/>
			
			<div class="site-info columns-5 small-row-padding flex space">
				<div class="logo" v-tooltip="'builder_change_host'" v-on:click="toggleChangeHost" :style="{backgroundImage : nodeFavicon(node.data.host)}"></div>
			
				<div class="columns-12 col-padding">
					<a class="host pink-color" v-bind:href="'http://'+node.data.host" target="_blank">{{node.data.host}}</a>
					
					<div class="more-info flex space">
						<div class="columns-7">
							<div class="uppercase" v-tooltip="(node.data.last_catch && lastCatchTimer >= 0)? 'builder_timer' : 'builder_avaialable'">Vairus</div>
						
							<div v-tooltip="(node.data.last_catch && lastCatchTimer >= 0)? 'builder_timer' : 'builder_avaialable'">
								<span v-if="node.data.last_catch && lastCatchTimer >= 0">{{getLocale('available_in')}} {{parseTime(lastCatchTimer)}}</span>
								<span v-else>{{getLocale('available')}}</span>
							</div>
						</div>
						
						<div class="columns-5">
							<div class="uppercase" v-tooltip="'builder_category'">{{getLocale('category')}}</div>
							<div v-tooltip="'builder_category'">{{getLocale(getBiome(node.data.host))}}</div>
						</div>
					</div>
				</div>
			</div>
			
			<svg class="circuit" :class="{full : current_process.length >= max_processes, active : node.data.assignment}" v-on:click="test = !test" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 500 500">
				<path d="M 0 110 L 215 110 L 215 10 L 250 10"/>
				<path d="M 0 197 L 150 196 L 150 170 L 250 170"/>
				<path d="M 0 282 L 190 282 L 190 326 L 250 326"/>
				<path d="M 0 365 L 170 365 L 170 485 L 250 485"/>
			</svg>
			
			<div class="assignment">
				<vairus-card 
					v-if="node.data.assignment"
					@clicked="requestList"
					:vairus="findVairus(node.data.assignment)"
					:highlighted="false"
					:show_footer="false"
					:hide_exhaustion="true"
					:stats="true"
					color="pink"
					glow="true"
				/>
				
				<empty-card v-else @clicked="requestList" />
			</div>

			<div class="secondary-structures columns-7" :class="{active : node.data.assignment, assigned : assigned}">
				<div class="wrapper flex space" v-for="(structure, index) in node.data.structures">
					<div class="structure-card"  :class="{
						active : current_process.length < max_processes && node.data.assignment && structure.level < structureMaxLevel(structure.id) && !current_process_by_type[structure.id],
						'locked green-color' : current_process_by_type[structure.id]
					}">
						<div class="action">
							<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 420 40">
								<path pointer-events="visible" stroke-width="2" fill="black" d="M 420 39 L 230 39 L 190 1 L 0 1 L 1 42 L 420 42 Z"></path>
							</svg>
							
							<div class="label flex space">
								<span>{{Math.floor(structureEffect(structure.id, structure.level)*100)}}%</span>
							</div>
						</div>
						
						<div class="info">
							<div class="top-bar flex space v-center">
							
								<div class="name flex v-center uppercase bold">
									<svg xmlns="http://www.w3.org/2000/svg" width="25" height="25" viewBox="0 0 25.002 25" :fill="current_process_by_type[structure.id] ? '#00FFB4' : '#9F5C9F'">
										<g v-if="index == 0" transform="translate(-3.03 -2.446)">
											<path d="M11.623,10.782,8.584,5.715a.546.546,0,0,0-.767-.181,10.868,10.868,0,0,0-4.786,8.279.55.55,0,0,0,.541.575l5.9.1a4.4,4.4,0,0,1,2.149-3.7Zm8.829-4.91a.549.549,0,0,0-.793.164l-3.041,5.072A4.388,4.388,0,0,1,18.3,14.5l5.9-.1a.552.552,0,0,0,.543-.577,10.873,10.873,0,0,0-4.292-7.949ZM16.023,18.4a4.273,4.273,0,0,1-4.274,0L8.872,23.582a.544.544,0,0,0,.225.753,10.874,10.874,0,0,0,9.576,0,.544.544,0,0,0,.225-.753L16.023,18.4Z"/>
											<path d="M19.28,16.39a2.89,2.89,0,1,1-2.89-2.89A2.89,2.89,0,0,1,19.28,16.39Z" transform="translate(-2.504 -1.748)"/>
										</g>
										<g v-if="index == 1" transform="translate(-1.125 -1.75)">
											<path d="M20.24,16.87a3.37,3.37,0,1,1-3.37-3.37A3.37,3.37,0,0,1,20.24,16.87Z" transform="translate(-3.107 -1.695)"/>
											<path d="M21.073,9.129A12.8,12.8,0,0,0,13.75,6.75,12.357,12.357,0,0,0,7.084,8.777a22.471,22.471,0,0,0-5.959,6.4A20.324,20.324,0,0,0,6.4,21.241a12.606,12.606,0,0,0,14.685,0A20.192,20.192,0,0,0,26.4,15.175,20.459,20.459,0,0,0,21.073,9.129Zm-7.31,11.1a5.055,5.055,0,1,1,5.055-5.055A5.055,5.055,0,0,1,13.763,20.23Z"/>
										</g>
										<path v-if="index == 2" d="M4.624,22.5a4.1,4.1,0,0,0,3.933,2.728h.068A3.475,3.475,0,0,0,12.03,28a3.386,3.386,0,0,0,1.578-.392,1.24,1.24,0,0,0,.643-1.1V4.284a1.247,1.247,0,0,0-.981-1.228,2.905,2.905,0,0,0-1.849.251A2.718,2.718,0,0,0,9.945,5.779v.069a3.473,3.473,0,0,0-3.43,5.541,4.17,4.17,0,0,0-1.6,7.627,4.31,4.31,0,0,0-.293,3.48ZM24.487,11.389a3.473,3.473,0,0,0-3.43-5.541V5.779A2.719,2.719,0,0,0,19.58,3.306a2.9,2.9,0,0,0-1.848-.251,1.248,1.248,0,0,0-.981,1.228V26.507a1.24,1.24,0,0,0,.645,1.1A3.37,3.37,0,0,0,18.973,28a3.475,3.475,0,0,0,3.4-2.778h.07A4.1,4.1,0,0,0,26.38,22.5a4.306,4.306,0,0,0-.293-3.48,4.171,4.171,0,0,0-1.6-7.626Z" transform="translate(-3 -3.002)"/>
										<path v-if="index == 3" d="M23.958,11.125h-7.5l1.667-10-12.5,15h7.5l-1.667,10Z" transform="translate(-5.625 -1.125)"/>
									</svg>
									{{getLocale('structure_'+structure.id)}}
								</div>
								<div class="level">LV<span class="bold">{{structure.level}}</span></div>
							</div>
							
							<div class="description">
								{{getLocale('structure_'+structure.id+'_effect')}}	
							</div>
						</div>
					</div>
					
					<transition name="fade">
						<div class="structure-upgrade uppercase" 
							:class="{ flip : current_process_by_type[structure.id] }"
							v-if="node.data.assignment && structure.level < structureMaxLevel(structure.id) && (current_process.length < max_processes || current_process_by_type[structure.id])"
							v-on:click="(current_process_by_type[structure.id]) ? stopBuilder(structure.id) : startBuilder(structure.id)"
						>
							<svg class="border" xmlns="http://www.w3.org/2000/svg" width="167" height="105" viewBox="0 0 167 105">
								<path class="bkg" stroke="#00FFB4" stroke-width="2" d="M 30 0 L 167 0 L 167 73 L 120 73 L 90 103 L 0 103 L 0 30 L 30 0" />
								<path stroke="black" stroke-width="1" fill="black" d="M 2 74 L 118 74 L 90 102 L 2 102 L 2 74" />
							</svg>
							
							<div class="button front flex h-center v-center">
								<svg xmlns="http://www.w3.org/2000/svg" width="30" height="30" viewBox="0 0 30 30">
									<g transform="translate(30 30) rotate(-180)" fill="black">
										<path d="M15,28.125A13.125,13.125,0,1,0,1.875,15,13.125,13.125,0,0,0,15,28.125ZM15,30A15,15,0,1,0,0,15,15,15,0,0,0,15,30Z" transform="translate(0 0)" fill-rule="evenodd"/>
										<path d="M10.4,17.152a.951.951,0,0,1,1.347,0l5.032,5.035,5.033-5.035A.952.952,0,1,1,23.162,18.5L17.456,24.2a.951.951,0,0,1-1.347,0L10.4,18.5a.951.951,0,0,1,0-1.347Z" transform="translate(-1.782 -2.88)" fill-rule="evenodd"/>
										<path d="M17.826,10.125a.951.951,0,0,1,.951.951v9.51a.951.951,0,0,1-1.9,0v-9.51A.951.951,0,0,1,17.826,10.125Z" transform="translate(-2.826 -1.761)" fill-rule="evenodd"/>
									</g>
								</svg>

								<div class="text">
									{{ getLocale('powerup') }}<br>
									— LV <span class="bold"> {{structure.level+1}}</span>
								</div>
							</div>
							
							<div class="button back flex h-center v-center">
								<svg xmlns="http://www.w3.org/2000/svg" width="36.003" height="27.005" viewBox="0 0 36.003 30">
									<g transform="translate(0.002 -4.497)" fill="#00FFB4">
										<path d="M6.421,16.078a1.125,1.125,0,0,0-1.593,0l-4.5,4.5a1.126,1.126,0,1,0,1.593,1.593l3.7-3.7,3.7,3.706a1.126,1.126,0,1,0,1.593-1.593l-4.5-4.5Zm29.25-2.25a1.125,1.125,0,0,0-1.593,0l-3.7,3.706-3.7-3.706a1.126,1.126,0,1,0-1.593,1.593l4.5,4.5a1.125,1.125,0,0,0,1.593,0l4.5-4.5a1.125,1.125,0,0,0,0-1.593Z" fill-rule="evenodd"/>
										<path d="M18,6.75a11.239,11.239,0,0,0-9.432,5.114,1.125,1.125,0,0,1-1.883-1.229A13.5,13.5,0,0,1,31.5,18a1.126,1.126,0,1,1-2.252,0A11.25,11.25,0,0,0,18,6.75ZM5.625,16.875A1.125,1.125,0,0,1,6.75,18a11.25,11.25,0,0,0,20.682,6.136,1.125,1.125,0,1,1,1.883,1.229A13.5,13.5,0,0,1,4.5,18a1.125,1.125,0,0,1,1.127-1.125Z" fill-rule="evenodd"/>
									</g>
								</svg>

								<div class="text">
									<span class="normal">{{ getLocale('ongoing_upgrade') }}</span>
									<span class="alt">{{ getLocale('cancel') }}</span>
								</div>
							</div>
							
							<div class="time front">{{ structureUpgradeTime(structure) }}</div>
							<div class="time back">{{ current_process_by_type[structure.id] ? parseTime(current_process_by_type[structure.id].end*1000 - current_time) : ''}}</div>
						</div>
					</transition>
				</div>			
			</div>			

		</div>
		
		
		<transition name="fade">
			<div class="change-host" v-if="change_host">
				<div class="backdrop" v-on:click.self="toggleChangeHost"></div>
				
				<div class="wrapper pink-gradient columns-12 center">	
					<div class="header flex space">
						<div class="hustle medium pink-color">{{getLocale('change_site')}}</div>
						
						<div class="description columns-12">{{getLocale('change_host_explanation')}}</div>
						
						<close-icon class="close-button" color="#feb3ff"  @clicked="toggleChangeHost"/>
					</div>
					
					<div class="info">
						<div class="flex" v-if="lastChangeTimer <= 0">
							<div class="logo":style="{backgroundImage : nodeFavicon((new_host != '')? new_host : node.data.host)}"></div>
							
							<div class="columns-10">
								<div class="last-site-selector">
									<div class="medium-font columns-6 lightpink-color">{{getLocale('select_site_from_list')}}</div>
							
									<div class="row-padding">
										<div class="avaiable-sites" v-if="validSites.length > 0">
											<div 
												class="website flex"
												v-for="site in validSites" 
												:class="{selected : new_host == site.url}" 
												v-on:click="new_host = site.url"
											>
												<div class="host columns-12 flex space">
													<div>{{site.url}}</div>
													<div>{{getLocale(getBiome(site.url))}}</div>
												</div>
												<div class="choose uppercase"><span>{{getLocale('choose')}}</span></div>
											</div>
										</div>
										
										<div v-else>{{getLocale('empty_last_sites')}}</div>
									</div>
								</div>
								
								<div class="flex">
									<v-button 
										:text="getLocale('change')"
										:disabled="new_host == ''"
										color="lightestpink"
										@clicked="changeHost"
									/>
								</div>
							</div>
						</div>
						
						<div class="timer medium-font" v-else>{{getLocale('time_left')}} {{parseTime(lastChangeTimer)}}</div>
					</div>
					
				</div>
			</div>
		</transition>
	</div>
</template>


<script>
	import { commonMixin } from '../../mixins/common.js';
	import { structuresMixin } from '../../mixins/structures.js';
	import { storeGettersMixin } from '../../mixins/store_getters.js';
	import NumberChanger from '../NumberChanger.vue';
	import VButton from '../VButton.vue';
	import VInfo from '../VInfo.vue';
	import TutorialIcon from '../TutorialIcon.vue';
	import CloseIcon from '../CloseIcon.vue';
	import VairusCard from '../VairusCard.vue';
	import EmptyCard from '../EmptyCard.vue';
	import structuresManager from '../../classes/structuresManagerClass.js';
	
	var browser = browser || chrome;
	
	export default {
		props: ['node', 'last_sites'],
		data: function () {
			return{
				gather_disabled : false,
				change_host : false,
				new_host : '',
				assigned: false
			}
		},
		mounted() {			
			if(this.node.data.assignment != null){
				this.assigned = true;
			}
			
			setTimeout(function(){
				if(!this.checkTutorial('network_profile')){
					this.setTutorial('network_profile', 4, false);
				}
			}.bind(this), 500);
		},
		computed: {
			production_time(){
				return this.current_time%3600000;
			},
			assigned_vairus(){
				let vairus = this.vairus_list.find(function(v){
					return v.unique_id == this.node.data.assignment;
				}.bind(this));
				
				return (typeof vairus !== 'undefined') ? vairus : null;
			},
			max_processes(){
				if(this.node.data.level >= 20) return 3;
				if(this.node.data.level >= 10) return 2;
				return 1;
			},
			current_process(){
				if(this.node.data.assignment == null) return [];
				
				return this.processes.filter(function(p){
					return p.vairus_id == this.node.data.assignment;
				}.bind(this));
			},
			current_process_by_type(){
				let processes = {};
				
				this.current_process.forEach(function(process){
					processes[process.data2] = process;
				});
				
				return processes;
			},
			lastCatchTimer(){
				return (this.node.data.last_catch+1800000) - this.current_time;
			},
			lastChangeTimer(){
				let time = this.nodes.reduce(function(time, node){
					return Math.max(time, node.last_change);
				}, 0);
				
				return (time == 0)? 0 : (24*60*60*1000)-(this.current_time-time);
			},
			validSites(){
				let current_hosts = this.nodes.map(function(node){ return node.host; });
				return this.last_sites.filter(function(site){
					return current_hosts.indexOf(site.url) === -1;
				});
			},
			stats_classes(){
				let classes = [];
				this.current_process.forEach(function(p){
					switch(p.data2){
						case 'dns': classes.push('hazard'); break;
						case 'decoder': classes.push('secrecy'); break;
						case 'firewall': classes.push('adaptability'); break;
						case 'analyzer': classes.push('rapidity'); break;
					}
				});
				
				return classes;
			}
		},
		methods: {
			requestList(){
				if(this.current_process.length > 0){
					if(confirm(this.getLocale('stop_process_warning'))){
						this.$emit('requestlist');
					}
				}else{
					this.$emit('requestlist');
				}
			},
			parseTime(timestamp){
				if(timestamp < 0) timestamp = 0;
			
				let d = Math.floor((timestamp / (1000 * 60 * 60 * 24)));
				timestamp -=  d*(1000 * 60 * 60 * 24);
				let h = Math.floor((timestamp / (1000 * 60 * 60)));
				let m = Math.floor((timestamp / (1000 * 60)) % 60);
				let s = Math.floor((timestamp / 1000) % 60);
				
				if(d > 0){
					return  d+'D '+h.toString().padStart(2, '0')+'H';
				}
				if(h > 0){
					return  h.toString().padStart(2, '0')+'H '+m.toString().padStart(2, '0')+'M';
				}
				
				return m.toString().padStart(2, '0')+'M '+s.toString().padStart(2, '0')+'S';
			},
			toggleChangeHost(){
				this.change_host = !this.change_host;
			},
			changeHost(){
				browser.runtime.sendMessage({
					type : 'change_host',
					data : { 
						node_id : this.node.id.replace('n', ''),
						site : this.new_host,
					}
				});
				
				this.toggleChangeHost();
			},
			startBuilder(structure_id){
				if(this.start_process_lock) return;
				this.$store.commit('setActionLock', 'start_process_lock');

				browser.runtime.sendMessage({
					type : 'start_builder',
					data : { 
						node_id : this.node.id.replace('n', ''),
						structure_id : structure_id
					}
				});
				
			},
			stopBuilder(structure_id){
				if(this.current_process.length > 0){
					if(confirm(this.getLocale('stop_builder_warning'))){
						browser.runtime.sendMessage({
							type : 'stop_process',
							data : this.current_process_by_type[structure_id].id
						});
					}
				}
			},
			structureUpgradeTime(structure){
				if(this.assigned_vairus == null) return '';
				
				let cost = this.structureUpgradeCost(structure.id, structure.level);
				let stat_type = this.structureStat(structure.id);
				let structure_stat = this.assigned_vairus.current_stats[stat_type].total;
				
				let builder_efficacy = this.structureEffect('builder', this.node.data.level);
				let vairus_efficacy = 1 + ((structure_stat*2)/154);
				
				return this.parseTime(Math.floor((cost/(builder_efficacy * vairus_efficacy))*1000))
			}
		},
		watch: {
			node: {
				handler: function(new_value) {
					if(new_value.data.assignment != null){
						setTimeout( () => this.assigned = true, 3000 );
					}
				},
				deep: true
			}
        },
		mixins: [commonMixin, structuresMixin, storeGettersMixin],
		components: {
			VairusCard,
			TutorialIcon,
			CloseIcon,
			EmptyCard,
			NumberChanger,
			VButton,
			VInfo
		}
	}
</script>


<style lang="scss">
	@import "../../styles/variables";

	.builder{
		.content{
			.site-info{
				.logo{
					width: 50px;
					height: 50px;
					border-radius: 50%;
					border: 5px solid $lightestpink;
					box-shadow: 0px 0px 30px 0px $lightestpink;
					background-position: center;
					background-repeat: no-repeat;
					background-size: 24px 24px;
					cursor: pointer;
					flex-shrink: 0;
				}
				
				.host{
					display: block;
					text-decoration: none;
					overflow: hidden;
					text-overflow: ellipsis;
					margin-top: -15px;
					margin-bottom: 5px;
				}
				.tutorial-button{
					top: 25px;
					right: 25px;
				}
				.more-info div{
					white-space: nowrap;
				}
			}
			
			.circuit{
				position: absolute;
				left: 42%;
				top: 50%;
				width: 455px;
				height: 455px;
				transform: translate(-50%, -50%);
				pointer-events: none;
				
				path{
					stroke: $lightestpink;
					stroke-width: 3;
					fill: none;
					stroke-dasharray: 400;
					stroke-dashoffset: 400;
					transition: stroke-dashoffset 2s;
					
					&:nth-child(1){
						transition-delay: 0.5s;
					}
					&:nth-child(2){
						transition-delay: 1s;
					}
					&:nth-child(3){
						transition-delay: 1.25s;
					}
					&:nth-child(4){
						transition-delay: 0.75s;
					}
				}
				
				&.active path{
					stroke-dashoffset: 0;
				}
				
				&.full path{
					stroke: #885A88;
				}
				
			}
			
			.assignment{
				position: absolute;
				top: 50%;
				left: 25px;
				transform: translateY(-50%);
				
				.vairus-card,
				.empty-card{
					margin: 0;
				}
				
			}
				
			.secondary-structures{
				opacity: 0.2;
				transition: opacity 0.2s;
				
				&.active{
					opacity: 1;
				}
				
			
				.structure-card{
					position: relative;
					margin-bottom: 22px;
					transition: opacity 0.2s;
					width: 420px;
					
					.action{
						position: relative;
						height: 40px;
						background-color: none;
						
						.powerup{
							position: absolute;
							left: 0;
							top: 0;
							width: 0;
							height: 100%;
							padding: 10px 0;
							cursor: pointer;
							color: black;
							background-color: $green;
							text-align: right;
							transition: all 0.3s;
							overflow: hidden;
							
							&:before{
								content:"";
								position:absolute;
								top:0;
								width: 100%;
								left: 0;
								bottom:0;
								background: linear-gradient(45deg, rgba(255, 255, 255, 0), rgba(255, 255, 255, 0) 20%, rgb(169, 255, 230) 49% 51%, rgba(255, 255, 255, 0) 75%, rgba(255, 255, 255, 0));
								animation:change 2s infinite linear;
							}
							
							&:hover:before{
								animation: change 1s infinite linear;
							}
								
							span{
								position: relative;
								z-index: 10;
							}
						}
						
						svg{
							position: absolute;
							left: 0;
							bottom: 0;
							pointer-events: none;
							stroke: $lightestpink;
						}
						
						.label{
							position: absolute;
							left: 0;
							top: -0;
							width: 100px;
							padding: 15px 10px;
							white-space: nowrap;
							text-align: center;
							
							span{
								line-height: 1;
							}
						}
						
					}
					
					.info{
						border: 2px solid $lightestpink;
						border-top: none;
						
						.top-bar{
							background-color: $darkestpink;
							padding: 5px 10px;
							
							svg{
								width: 20px;
								height: 20px;
								margin-right: 5px;
							}
							
							> div{
								line-height: 1;
							}
						}
						.description{
							padding: 7px 10px;
							line-height: 1.2;
							
							.info-box{
								position: absolute;
								bottom: calc(0% - 17px);
								left: 50%;
								transform: translateX(-50%);
							}
						}
					}
					
					&.active{
						.action{
							.powerup{
								width: 100%;
								padding: 10px;
								
								.is-locked{
									display: none;
								}
							}
						}
					
						&:nth-child(1){
							transition-delay: 1.7s;
							.action .powerup{
								transition-delay: 1.7s;
							}
						}
						&:nth-child(2){
							transition-delay: 1.8s;
							.action .powerup{
								transition-delay: 1.8s;
							}
						}
						&:nth-child(3){
							transition-delay: 2.05s;
							.action .powerup{
								transition-delay: 2.05s;
							}
						}
						&:nth-child(4){
							transition-delay: 1.95s;
							.action .powerup{
								transition-delay: 1.95s;
							}
						}
					} 
					
					&.locked{
						opacity: 1;
						
						.action{
							.powerup{
								width: 100%;
								padding: 10px;
								background-color: $black;
								color: $green;
								
								&:before,
								.is-active{
									display: none;
								}
							}
							svg{
								stroke: $green;
							}
						}
						.info{
							border-color: $green;
							.top-bar{
								background-color: $darkestgreen;
							}
						}
					}
				}
				
				
				&.assigned{
					.structure-card{
						transition-delay: 0s !important;
						
						.action .powerup{
							transition-delay: 0s !important;
						}
					}
				}
				
				.structure-upgrade{
					position: relative;
					width: 167px;
					height: 105px;
					margin-bottom: 20px;
					margin-left: 5px;
					cursor: pointer;
					
					svg.border{
						position: absolute;
						transition: transform 0.5s;
						transform-style: preserve-3d;
						transform: rotateY(0deg);
						
						.bkg{
							fill: #00FFB4;
							transition: fill 0.5s;
						}
					}
					
					.button{
						position: absolute;
						width: calc(100% - 6px);
						left: 3px;
						top: 3px;
						color: black;
						height: 70px;
						padding: 10px;
						transition: transform 0.5s;
						transform-style: preserve-3d;
						backface-visibility: hidden;
						
						svg{
							margin-right: 10px;
						}
						
						.text{
							width: 90px;
							
							.alt{
								display: none;
							}
						}
						
						&.back{
							color: $green;
						}
					}
			
					.time{
						position: absolute;
						width: calc(100% - 6px);
						left: 3px;
						bottom: 3px;
						color: $green;
						height: 32px;
						line-height: 32px;
						padding: 0 10px;
						transition: transform 0.5s;
						transform-style: preserve-3d;
						backface-visibility: hidden;
						
						&.back{
							text-align: right;
						}
					}
					
					.front{
						transform: rotateY(0deg);
					}
					.back{
						transform: rotateY(180deg);
					}
					
					&.flip{
						svg.border{
							transform: rotateY(180deg);
							
							.bkg{
								fill: #0E3930;
							}
						}
						.front{
							transform: rotateY(180deg);
						}
						.back{
							transform: rotateY(0deg);
						}
					}
					&:hover .button{
						.normal{
							display: none;
						}
						.alt{
							display: block;
						}
					}
				}
				
				.wrapper:last-child .structure-card,
				.wrapper:last-child .structure-upgrade{
					margin-bottom: 0;
				}
			}
		}

		
		.change-host{
			position: absolute;
			top: 0;
			left: 0;
			bottom: 0;
			right: 0;
			z-index: 20;
			
			.backdrop{
				position: absolute;
				top: 0;
				left: 0;
				bottom: 0;
				right: 0;
				background-color: rgba(0, 0, 0, 0.7);
			}
			
			.wrapper{
				position: absolute;
				top: 50%;
				left: 50%;
				transform: translate(-50%, -50%);
				border-radius: 10px;
				padding: 20px;
				
				.header{
					.hustle{
						white-space: nowrap;
					}
					
					.description{
						padding-left: 100px;
						padding-right: 50px;
					}
				}
				

				.info{
					margin-top: 20px;
				
					.logo{
						width: 50px;
						height: 50px;
						margin-right: 20px;
						border-radius: 50%;
						border: 5px solid $lightazure;
						box-shadow: 0px 0px 30px 0px $lightazure;
						background-position: center;
						background-repeat: no-repeat;
						background-size: 24px 24px;
						flex-shrink: 0;
					}
							
					.avaiable-sites{
						border-spacing: 0;
					
						.website{
							background-color: $darkestpink;
							border-radius: 10px;
							margin-bottom: 10px;
							cursor: pointer;
							
							.host{
								padding: 10px 20px;
								transition: all 0.2s;
							}
							.choose{
								padding: 10px 20px;
								background-color: $lightestpink;
								color: $darkestpink;
								border-top-right-radius: 10px;
								border-bottom-right-radius: 10px;
								
								span{
									opacity: 1;
									transition: opacity 0.2s;
								}
							}
							
							&.selected{
								.host{
									padding: 10px 20px;
									background-color: $lightestpink;
									color: $darkestpink;
									border-top-left-radius: 10px;
									border-bottom-left-radius: 10px;
								}
								.choose span{
									opacity: 0;
								}
							}
						}
					}
				}
			}
		}
		
		&.hazard .assignment .vairus-stats .hazard .image,
		&.secrecy .assignment .vairus-stats .secrecy .image,
		&.adaptability .assignment .vairus-stats .adaptability .image,
		&.rapidity .assignment .vairus-stats .rapidity .image{
			background-color: $lightestgreen;
		}
		
		&.hazard .circuit path:nth-child(1),
		&.secrecy .circuit path:nth-child(2),
		&.adaptability .circuit path:nth-child(3),
		&.rapidity .circuit path:nth-child(4){
			stroke: $green;
		}
		
		
		@media screen and (max-width: 1050px) {
			.empty-card{
				width: 175px !important;
				height: 250px !important;
			}
			.vairus-card{
				width: 214px !important;
				height: 250px !important;
				
				.vairus-stats .stat{
					padding: 5px 0;
					
					.image{
						width: 20px;
						height: 20px;
						
						img{
							left: 2px;
							top: 2px;
							right: 2px;
							bottom: 2px;
							width: 16px;
							height: 16px;
						}
					}
				}
			}
			.circuit{
				display: none;
			}
			.site-info{
				width: 30%;
				.more-info{
					display: block;
					
					> div:first-child{
						margin-bottom: 10px;
					}
				}
			}
			.secondary-structures{
				width: 70%;
			}
			.assignment{
				margin-top: 50px;
			}
		}
		@media screen and (max-width: 900px) {
			.content{
				display: block;
				
				.assignment{
					top: 25px;
					right: 25px;
					left: unset;
					margin-top: 0;
					transform: none;
				}
				
				.secondary-structures{
					width: 100%;
					margin-top: 150px;
					
					.structure-upgrade{
						flex-shrink: 0;
					}
				}
			}
		}
		@media screen and (max-width: 700px) {
			.secondary-structures{
				margin-top: 260px !important;
				
				> .wrapper{
					margin: 0 -15px;
				}
				.structure-card {
					overflow: hidden;
					
					svg{
						min-height: 37px;
					}
				}
			}
			.site-info{
				width: 100% !important;
				
				.more-info{
					display: flex !important;
				}
			}
			.assignment{
				left: 25px !important;
				top: 100px !important;
			}
		}
		@media screen and (max-width: 600px) {
			.change-host .wrapper .header .description{
				padding-left: 25px;
				padding-right: 35px;
			}
		}
		@media screen and (max-width: 500px) {
			.secondary-structures{
				.structure-card {
					svg{
						min-height: 30px;
					}
				}
				.structure-upgrade {
					width: 130px !important;
					
					svg{
						width: 100%;
					}					
					.time{
						line-height: 22px !important;
						left: 0 !important;
						padding: 0 5px !important;
					}
				}
			}
			.level-bar{
				display: none;
			}
			.header {
				margin-bottom: -20px !important;
			}
		}
		@media screen and (max-width: 400px){
			.secondary-structures > .wrapper{
				display: block;
				
				.structure-card {
					width: 100% !important; 
					margin-bottom: 0;
				}
			}
		}
	}
	
	@media screen and (max-width: 900px) {
		#nodes .structure-panel > .wrapper .panel.columns-8[data-type="builder"]{
			width: 670px !important;
		}
	}
	
	@-webkit-keyframes run {
		0% { left: 0;}
		100%{ left : 100%;}
	}
	@keyframes change {
		to { transform:translate(84%); }
	}
</style>



</style>





